import { Action } from "redux";
import { ActionCreator } from "redux-typescript-actions";
export interface ReducerBuilder<S> {
    case<P>(actionCreator: ActionCreator<P>, handler: Handler<S, P>): ReducerBuilder<S>;
    (state: S | undefined, action: Action): S;
}
export interface Handler<S, P> {
    (state: S, payload: P): S;
}
export declare function reducerWithInitialState<S>(initialValue: S): ReducerBuilder<S>;
export declare function reducerWithoutInitialState<S>(): ReducerBuilder<S>;
