"use strict";
var redux_typescript_actions_1 = require("redux-typescript-actions");
function reducerWithInitialState(initialValue) {
    return makeReducer([], initialValue);
}
exports.reducerWithInitialState = reducerWithInitialState;
function reducerWithoutInitialState() {
    return makeReducer([]);
}
exports.reducerWithoutInitialState = reducerWithoutInitialState;
function makeReducer(cases, initialValue) {
    var reducer = (function (state, action) {
        if (state === void 0) { state = initialValue; }
        for (var i = 0, length_1 = cases.length; i < length_1; i++) {
            var _a = cases[i], actionCreator = _a.actionCreator, handler = _a.handler;
            if (redux_typescript_actions_1.isType(action, actionCreator)) {
                return handler(state, action.payload);
            }
        }
        return state;
    });
    reducer.case = function (actionCreator, handler) {
        return makeReducer(cases.concat([{ actionCreator: actionCreator, handler: handler }]), initialValue);
    };
    return reducer;
}
//# sourceMappingURL=index.js.map